package controller

import (
	"math"
	"strconv"

	"gitlab.com/mbugroup/lti-api.git/internal/modules/master/nonstocks/dto"
	service "gitlab.com/mbugroup/lti-api.git/internal/modules/master/nonstocks/services"
	validation "gitlab.com/mbugroup/lti-api.git/internal/modules/master/nonstocks/validations"
	"gitlab.com/mbugroup/lti-api.git/internal/response"

	"github.com/gofiber/fiber/v2"
)

type NonstockController struct {
	NonstockService service.NonstockService
}

func NewNonstockController(nonstockService service.NonstockService) *NonstockController {
	return &NonstockController{
		NonstockService: nonstockService,
	}
}

func (u *NonstockController) GetAll(c *fiber.Ctx) error {

	query := &validation.Query{
		Page:       c.QueryInt("page", 1),
		Limit:      c.QueryInt("limit", 10),
		Search:     c.Query("search", ""),
		SupplierID: uint(c.QueryInt("supplier_id", 0)),
	}

	if query.Page < 1 || query.Limit < 1 {
		return fiber.NewError(fiber.StatusBadRequest, "page and limit must be greater than 0")
	}

	result, totalResults, err := u.NonstockService.GetAll(c, query)
	if err != nil {
		return err
	}

	return c.Status(fiber.StatusOK).
		JSON(response.SuccessWithPaginate[dto.NonstockListDTO]{
			Code:    fiber.StatusOK,
			Status:  "success",
			Message: "Get all nonstocks successfully",
			Meta: response.Meta{
				Page:         query.Page,
				Limit:        query.Limit,
				TotalPages:   int64(math.Ceil(float64(totalResults) / float64(query.Limit))),
				TotalResults: totalResults,
			},
			Data: dto.ToNonstockListDTOs(result),
		})
}

func (u *NonstockController) GetOne(c *fiber.Ctx) error {
	param := c.Params("id")

	id, err := strconv.Atoi(param)
	if err != nil {
		return fiber.NewError(fiber.StatusBadRequest, "Invalid Id")
	}

	result, err := u.NonstockService.GetOne(c, uint(id))
	if err != nil {
		return err
	}

	return c.Status(fiber.StatusOK).
		JSON(response.Success{
			Code:    fiber.StatusOK,
			Status:  "success",
			Message: "Get nonstock successfully",
			Data:    dto.ToNonstockDetailDTO(*result),
		})
}

func (u *NonstockController) CreateOne(c *fiber.Ctx) error {
	req := new(validation.Create)

	if err := c.BodyParser(req); err != nil {
		return fiber.NewError(fiber.StatusBadRequest, "Invalid request body")
	}

	result, err := u.NonstockService.CreateOne(c, req)
	if err != nil {
		return err
	}

	return c.Status(fiber.StatusCreated).
		JSON(response.Success{
			Code:    fiber.StatusCreated,
			Status:  "success",
			Message: "Create nonstock successfully",
			Data:    dto.ToNonstockDetailDTO(*result),
		})
}

func (u *NonstockController) UpdateOne(c *fiber.Ctx) error {
	req := new(validation.Update)
	param := c.Params("id")

	id, err := strconv.Atoi(param)
	if err != nil {
		return fiber.NewError(fiber.StatusBadRequest, "Invalid Id")
	}

	if err := c.BodyParser(req); err != nil {
		return fiber.NewError(fiber.StatusBadRequest, "Invalid request body")
	}

	result, err := u.NonstockService.UpdateOne(c, req, uint(id))
	if err != nil {
		return err
	}

	return c.Status(fiber.StatusOK).
		JSON(response.Success{
			Code:    fiber.StatusOK,
			Status:  "success",
			Message: "Update nonstock successfully",
			Data:    dto.ToNonstockDetailDTO(*result),
		})
}

func (u *NonstockController) DeleteOne(c *fiber.Ctx) error {
	param := c.Params("id")

	id, err := strconv.Atoi(param)
	if err != nil {
		return fiber.NewError(fiber.StatusBadRequest, "Invalid Id")
	}

	if err := u.NonstockService.DeleteOne(c, uint(id)); err != nil {
		return err
	}

	return c.Status(fiber.StatusOK).
		JSON(response.Common{
			Code:    fiber.StatusOK,
			Status:  "success",
			Message: "Delete nonstock successfully",
		})
}
